openr,2,'omega_path'
datapath=''
geompath=''
readf,2,datapath
readf,2,geompath
close,2
nomfic=' '
start:
print,'OMEGA observation: '
read,nomfic
nomgeo=nomfic+'.NAV'
nomfic=nomfic+'.QUB'
nomfic=datapath+nomfic
openr,2,nomfic,ERROR=errflag
close,2
if (errflag ne 0) then begin
  print,'file ',nomfic,' not found'
  goto, start
endif
readcube, nomfic, idat, sdat0, sdat1,info
exposure=0
exposure=info(0:2)
summation=info(3)
bits_per_data=info(4)
nomgeo=geompath+nomgeo

openr,1,nomgeo,ERROR=errflag
if(errflag ne 0) then begin
  print,' no corresponding NAV cube'
  close,1
  dmars=1.52
  specmars=fltarr(352)
  openr,2,'specsol_0403.dat'
  readf,2,specmars
  close,2
  specmars=specmars/dmars/dmars     
  goto, nogeom
endif
trans= !pi/180.*1.e-4

geocube=0B
ilec=0B

read_geolbl,nomgeo, '', values, data

lrec   = data(0)
nrec   = data(1)
npixel = data(2)
npara  = data(3)
nscan  = data(4)
nau    = data(5)
dmars=nau*1.e-4
close,2
openr,2,'specsol_0403.dat'
specmars=0B
specmars=fltarr(352)
readf,2,specmars
close,2
specmars=specmars/dmars/dmars

data = 0B
geocube=0B

geocube = lonarr(npixel, npara, nscan)
ilec = lonarr(npixel)

point_lun,1,lrec*nrec

for  k=0,nscan-1 do begin
   for j=0,npara-1 do begin
      readu, 1, ilec
      geocube(*,j,k) = ilec
   endfor
endfor
close, 1
if(geocube(1,1,0) gt 13) then geocube=swap_endian(temporary(geocube))
longi=reform(geocube(*,6,*)*1.e-4)
lati=reform(geocube(*,7,*)*1.e-4)
alt=reform(geocube(*,12,*)*1.e-3)
nogeom: 
close,/all
; preliminary pipeline tool

a=size(idat)
nbal=a(3)
indi=where(sdat1(14,1,*) ge 6 and sdat0(10,*) gt 100)
npix=a(1)
jdat=0
jdat=float(idat)
i=where(idat le 0) 
if(i(0) ne -1) then jdat(i)=1.e-3
pix0IR=0
i=where(idat(*,0:255,*) le 0)
if(i(0) ne -1) then pix0IR=(size(i))(3)
print,'       0 or less  IR: ',pix0IR

sdats=0
sdats=float(sdat0(0:255,*))
ndeb=min(indi)
indj=ndeb+indgen(nbal-ndeb)
for k=0,255 do begin
  a=poly_fit(indi,sdats(k,indi),2,b)
  sdats(k,indi)=b-sdat0(k,indi) 
  for i=0,npix-1 do jdat(i,k,ndeb:nbal-1)=jdat(i,k,ndeb:nbal-1)+sdats(k,ndeb:nbal-1)
endfor

if(summation ne 1) then jdat=jdat/summation
linearC=0
linearC=fltarr(4096)
openr,2,'linearC.dat'
readf,2,linearC
close,2
jdat(*,0:127,*)=linearC(fix(jdat(*,0:127,*)+0.5))
wvl=0
wvl=fltarr(352)
openr,2,'lambda_0403.dat'
readf,2,wvl
close,2
mtf=fltarr(352)
openr,2,'mtf050110_50.dat'
if(exposure(0) lt 4.) then begin
  close,2
  openr,2,'mtf050110_25.dat'
endif
readf,2,mtf
close,2
for n=0,255 do jdat(*,n,*)=jdat(*,n,*)/mtf(n)

;**************************************************************************************************************************
;bit error correction
;**************************************************************************************************************************

vis=float(idat(*,256:351,*))
siz = size(idat)
lines = siz (3)
pixels = siz(1)
exptime = info(2)/1000.
image_ratio = fltarr(pixels, lines)

level = 4095.

; In modes 128, selects a 8191 level
if pixels EQ 128 then level =20000.;8191.

i=where(vis le 0) 
counter_neg=0
if(i(0) ne -1) then begin
  counter_neg=(size(i))(3)
  vis(i)=0.001
endif

i=where(vis gt level)
counter_pos=0
if(i(0) ne -1) then begin 
  counter_pos=(size(i))(3)
  vis(i)=9000.
endif

median_line = fltarr(lines)
column = fltarr(lines)

counter_spikes=long(0)

for k = 0, 95 do begin
    for m = 0, pixels - 1 do begin
       column(*) = vis(m, k, *)
       median_line = median(column, 7)
         for i = 0, lines-1 do begin
          if (abs(median_line(i) - vis(m, k, i)) GT 200) then begin
          vis(m, k, i) = median_line(i)
          counter_spikes = counter_spikes + 1
          endif
         endfor
    endfor
endfor

print, '       0 or less VIS:', counter_neg
print, 'anomalous pixels VIS:', counter_pos
print, '          spikes VIS:', counter_spikes

vis = float(fix(vis))

;******************************************************************************************************************************
;flat cube
;******************************************************************************************************************************

slice = ulonarr(128, 96)

openr, 1, 'flatVIS.bin'
readu, 1, slice
close, 1
if(slice(48,0) gt 40000) then slice=swap_endian(slice)


istart= (128 - pixels)/2.
iend  = istart + pixels - 1

for i = 0, lines-1 do begin

    vis(*, *, i) = vis(*, *, i) * 2.^15 / slice(istart:iend, *)

endfor

;***************************************************************************************************************************
;radiometric calibration
;***************************************************************************************************************************

f = 1.
if pixels eq 128 then  f = 2; internal summation
f2 = 1.
if exptime eq 0.1 then f2 = 2.
if exptime eq 0.2 then f2 = 4.

spectrum = fltarr(96)

for i = 0, lines - 1 do begin
    for m = 0, pixels - 1 do begin
       spectrum = vis(m, *, i)
       jdat(m, 256:351, i) = 0.88*ordcorr(wvl(256:351), spectrum)/ ( f2 * mtf(256:351)) / f / summation
    endfor
    ;print, 'done %', 100*float(i)/(lines - 1)
endfor

close,/all
end
